VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TTPolyCurve"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'---------------------------------------------------------------------------------------
' Klasse    : TTPolyCurve
' Datum     : 21.01.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Kapselung einer TTPOLYCURVE-Struktur
'---------------------------------------------------------------------------------------

Option Explicit

Private m_lbound    As Long         ' Index auf eine TTPOLYCURVE-Struktur in einem TTPolyData-Objekt
Private m_Id        As Long         ' Kennung der PolyCurve
Private m_PolyData  As TTPolyData   ' Verweis auf ein TTPolyData-Objekt

'---------------------------------------------------------------------------------------
' Eigenschaften / Methoden
'---------------------------------------------------------------------------------------

'/ Typ der Polykurve - Polyline oder Qspline
Public Property Get PolyCurveType() As EPolyCurveType
    PolyCurveType = CLng(m_PolyData.Int16(m_lbound))
End Property

'/ Kennung bergeben
Public Property Get Id() As Long
    Id = m_Id
End Property

'/ Anzahl von PointFx-Strukturen der Polykurve bergeben
Public Property Get Count() As Long
    Count = CLng(m_PolyData.Int16(m_lbound + 1))
End Property

'/ PointFx-Struktur der Polykurve bergeben
Public Property Get Item(ByVal idx As Long) As PointFx 'Default Property
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
    If idx >= 0 Then
        If idx < m_PolyData.Int16(m_lbound + 1) Then
            Item = m_PolyData.PointFx(m_lbound + 2 + 4 * idx)
        End If
    End If
End Property

'/ Zeichen
Public Sub Draw(ByVal hdc As Long, ByVal xOffset As Long, ByVal yOffset As Long)
    m_PolyData.DrawPolyCurve hdc, xOffset, yOffset, m_lbound
End Sub

'/ Plot-Koordinaten bergeben
Public Function GetPlotPoints(Optional ByVal BzierPrecision As Long = 5) As Variant
    If BzierPrecision < 0 Then BzierPrecision = 0
    m_PolyData.GetPlotPoints GetPlotPoints, BzierPrecision, m_lbound
End Function

'/ Initialisierung
Friend Sub init(ByVal PolyData As TTPolyData, ByVal Id&, ByVal Lo&)
    Set m_PolyData = PolyData
    m_Id = Id
    m_lbound = Lo
End Sub

'---------------------------------------------------------------------------------------
' Ereignisse
'---------------------------------------------------------------------------------------

Private Sub Class_Terminate()
    '/ Aufrumen
    Set m_PolyData = Nothing
End Sub
