VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TTPolyCurves"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'---------------------------------------------------------------------------------------
' Klasse    : TTPolyCurves
' Datum     : 21.01.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Auflistung von Polykurven
'---------------------------------------------------------------------------------------

Option Explicit

Private m_colPC As Collection


'---------------------------------------------------------------------------------------
' Eigenschaften / Methoden
'---------------------------------------------------------------------------------------

'/ Eine Polykurve von der Auflistung bergeben
Public Property Get Item(ByVal Index As Long) As TTPolyCurve ' Default Procedure
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
    Set Item = m_colPC(Index)
End Property

'/ Anzahl Polykurven bergeben
Public Property Get Count() As Long
    Count = m_colPC.Count
End Property

'/ NewEnum aus NewEnumVariant der Auflistung *m_colPC* implementieren.
'/ (Ermglicht eine For..Each-Schreibweise)
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = m_colPC.[_NewEnum]
End Property

'/ Klasse initialisieren / Polykurven-Objekte anlegen
Friend Sub init(ByVal PolyData As TTPolyData, ByVal size&, ByVal offset&)
    Dim curpos      As Long
    Dim PolyCurve   As TTPolyCurve
    Dim cPointFx    As Integer
    Dim n           As Long
    
    '/ TTPOLYCURVE-Strukturen durchlaufen
    Do Until curpos >= size
        n = n + 1
        ' Anzahl von Polykurven ermitteln (cpfx aus TTPOLYCURVE)
        cPointFx = PolyData.Int16(offset + curpos + 1)
        
        ' Objekt erzeugen und initialisieren
        Set PolyCurve = New TTPolyCurve
        PolyCurve.init PolyData, n, offset + curpos
        
        ' Objekt zur Auflistung hinzufgen
        m_colPC.Add PolyCurve
        
        ' Nchste Polykurve
        curpos = curpos + 2 + 4 * cPointFx
    Loop

End Sub


'---------------------------------------------------------------------------------------
' Ereignisse
'---------------------------------------------------------------------------------------

Private Sub Class_Initialize()
    Set m_colPC = New Collection
End Sub


Private Sub Class_Terminate()
    Dim PolyCurve As TTPolyCurve

    '/ Aufrumen
    For Each PolyCurve In m_colPC
        Set PolyCurve = Nothing
    Next PolyCurve
    
    Set m_colPC = Nothing
End Sub


