VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TTPolyData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Klasse    : TTPolyData
' Datum     : 21.01.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Verwaltung der TTPOLYGON-Strukturen.
'             Zeichenfunktionen fr TTPOLYGONE.
'             Berechnung von Plotpunkten.
'---------------------------------------------------------------------------------------

Option Explicit

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function MoveToEx& Lib "gdi32" (ByVal hdc&, ByVal x&, ByVal y&, lpPoint As Any)
Private Declare Function LineTo& Lib "gdi32" (ByVal hdc&, ByVal x&, ByVal y&)
Private Declare Function GetCurrentPositionEx& Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI)

Private Const BZIERDEPTH& = 15

Private m_aiData()  As Integer
Private m_DrawMode  As Integer


Friend Sub init(ByVal BufferSize&)
    ReDim Preserve m_aiData(BufferSize \ 2 - 1)
End Sub

Friend Property Get DataPointer() As Long
    If Not Not m_aiData Then DataPointer = VarPtr(m_aiData(0))
End Property

Friend Property Get Int16(ByVal idx&) As Integer
    Int16 = m_aiData(idx)
End Property

Friend Property Get Int32(ByVal idx&) As Long
    Int32 = (m_aiData(idx + 1) * &H10000) Or m_aiData(idx)
End Property

Friend Property Get PointFx(ByVal idx&) As PointFx
    PointFx.x.fract = m_aiData(idx)
    PointFx.x.value = m_aiData(idx + 1)
    PointFx.y.fract = m_aiData(idx + 2)
    PointFx.y.value = m_aiData(idx + 3)
End Property

Friend Property Get size() As Long
    size = UBound(m_aiData()) * 2 + 2
End Property

Friend Sub SetStartPoint(ByVal hdc&, ByVal dx&, ByVal dy&, ByVal idxPointFx&)
    Dim x       As Long
    Dim y       As Long
    
    x = m_aiData(idxPointFx + 1)
    y = m_aiData(idxPointFx + 3)
    MoveToEx hdc, x + dx, y + dy, ByVal 0&
End Sub

Friend Sub DrawPolygon(ByVal hdc&, ByVal dx&, ByVal dy&, ByVal idxPolygon&)
    Dim hi  As Long
    Dim idx As Long
    Dim x   As Long
    Dim y   As Long
    
    hi = Int32(idxPolygon) \ 2 + idxPolygon
    
    SetStartPoint hdc, dx, dy, idxPolygon + 4
    idx = idxPolygon + 8
    m_DrawMode = 1 'DrawPolyCurve braucht keine Startpunkte setzen

    Do
        idx = DrawPolyCurve(hdc, dx, dy, idx)
    Loop Until idx >= hi
    
    'Polygon schliessen
    x = m_aiData(idxPolygon + 5)
    y = m_aiData(idxPolygon + 7)
    LineTo hdc, x + dx, y + dy
    
    m_DrawMode = 0
End Sub


''---------------------------------------------------
Friend Function GetPlotPoints(ByRef vResult As Variant, ByVal Precision&, ByVal idxPolyCurve&)
    Dim c       As Long
    Dim offset  As Long
    Dim x       As Long
    Dim y       As Long
    Dim cptf    As Long     'Anzahl PointFX-Strukturen aus TTPOLYCURVE
    Dim p1      As POINTSNG
    Dim p2      As POINTSNG
    Dim p3      As POINTSNG
    Dim ax()    As Single
    Dim ay()    As Single
    Dim aPS()   As POINTSNG
    Dim nPS     As Long
    
    cptf = m_aiData(idxPolyCurve + 1)
    
    ReDim Preserve aPS(1024)
    
    '/ Startpunkt
    AddPointSng aPS(), GetSingle(idxPolyCurve - 4), GetSingle(idxPolyCurve - 2), nPS
    
    offset = 2
    
    If m_aiData(idxPolyCurve) = TT_PRIM_LINE Then 'Typ aus TTPOLYCURVE
        ' Polyline
        For c = 0 To cptf - 1
            AddPointSng aPS(), GetSingle(idxPolyCurve + offset), GetSingle(idxPolyCurve + offset + 2), nPS
            offset = offset + 4
        Next c
    Else
        ' Qspline
        ReDim Preserve ax(cptf - 1)
        ReDim Preserve ay(cptf - 1)
        For c = 0 To cptf - 1
            ax(c) = GetSingle(idxPolyCurve + offset)
            ay(c) = GetSingle(idxPolyCurve + offset + 2)
            offset = offset + 4
        Next c
        
        For c = 0 To cptf - 2
            p1 = aPS(nPS - 1)
                                    
            p2.x = ax(c)
            p2.y = ay(c)
            
            If (cptf - c) < 3 Then
                p3.x = ax(c + 1)
                p3.y = ay(c + 1)
            Else
                p3.x = p2.x + (ax(c + 1) - p2.x) \ 2
                p3.y = p2.y + (ay(c + 1) - p2.y) \ 2
            End If
                        
            Qspline p1, p2, p3, Precision, aPS(), nPS
        Next c
    End If
    ReDim Preserve aPS(nPS - 1)
    vResult = aPS()
End Function

Private Sub AddPointSng(aPS() As POINTSNG, ByVal x!, ByVal y!, ByRef idx&)
    If idx > UBound(aPS()) Then ReDim Preserve aPS(idx + 1024)
    aPS(idx).x = x
    aPS(idx).y = y
    idx = idx + 1
End Sub

Private Sub Qspline(p1 As POINTSNG, p2 As POINTSNG, p3 As POINTSNG, ByVal Precision&, aPS() As POINTSNG, nPS As Long)
    Dim c   As Long
    Dim r   As Double
    Dim r2  As Double
    Dim x   As Single
    Dim y   As Single

    p2.x = p2.x * 2
    p2.y = p2.y * 2

    For c = 0 To Precision
        r = c * (1 / Precision)
        r2 = r * r
        x = (p1.x - p2.x + p3.x) * r2 + (p2.x - 2 * p1.x) * r + p1.x
        y = (p1.y - p2.y + p3.y) * r2 + (p2.y - 2 * p1.y) * r + p1.y
        AddPointSng aPS(), x, y, nPS
    Next c
End Sub

Friend Function DrawPolyCurve(ByVal hdc&, ByVal dx&, ByVal dy&, ByVal idxPolyCurve&) As Long
    Dim c       As Long
    Dim offset  As Long
    Dim x       As Long
    Dim y       As Long
    Dim cptf    As Long     'Anzahl PointFX-Strukturen aus TTPOLYCURVE
    Dim pA      As POINTAPI
    Dim p1      As POINTSNG
    Dim p2      As POINTSNG
    Dim p3      As POINTSNG
    Dim ax()    As Single
    Dim ay()    As Single
    
    If m_DrawMode = 0 Then  'Startpunkt setzen
        x = GetSingle(idxPolyCurve - 4)
        y = GetSingle(idxPolyCurve - 2)
        MoveToEx hdc, x + dx, y + dy, ByVal 0&
    End If
    
    cptf = m_aiData(idxPolyCurve + 1)
    offset = 2
    
    If m_aiData(idxPolyCurve) = TT_PRIM_LINE Then 'Typ aus TTPOLYCURVE
        ' Zeichne Polyline
        For c = 0 To cptf - 1
            x = GetSingle(idxPolyCurve + offset)
            y = GetSingle(idxPolyCurve + offset + 2)
            
            LineTo hdc, x + dx, y + dy
            offset = offset + 4
        Next c
    Else
        ' Zeichne Qspline
        ReDim Preserve ax(cptf - 1)
        ReDim Preserve ay(cptf - 1)
        For c = 0 To cptf - 1
            ax(c) = dx + GetSingle(idxPolyCurve + offset)
            ay(c) = dy + GetSingle(idxPolyCurve + offset + 2)
            offset = offset + 4
        Next c
        
        For c = 0 To cptf - 2
            GetCurrentPositionEx hdc, pA
            p1.x = pA.x
            p1.y = pA.y
                                    
            p2.x = ax(c)
            p2.y = ay(c)
            
            If (cptf - c) < 3 Then
                p3.x = ax(c + 1)
                p3.y = ay(c + 1)
            Else
                p3.x = p2.x + (ax(c + 1) - p2.x) \ 2
                p3.y = p2.y + (ay(c + 1) - p2.y) \ 2
            End If
                        
            DrawQspline hdc, p1, p2, p3
        Next c
    End If
    
    DrawPolyCurve = idxPolyCurve + cptf * 4 + 2 ' Offset auf die nchste Polykurve
End Function

Private Sub DrawQspline(ByVal hdc&, p1 As POINTSNG, p2 As POINTSNG, p3 As POINTSNG)
    Dim c   As Long
    Dim r   As Double
    Dim r2  As Double
    Dim x   As Long
    Dim y   As Long
    
    p2.x = p2.x * 2
    p2.y = p2.y * 2
    
    For c = 0 To BZIERDEPTH
        r = c * (1 / BZIERDEPTH)
        r2 = r * r
        x = (p1.x - p2.x + p3.x) * r2 + (p2.x - 2 * p1.x) * r + p1.x
        y = (p1.y - p2.y + p3.y) * r2 + (p2.y - 2 * p1.y) * r + p1.y
        LineTo hdc, x, y
    Next c

End Sub

Private Function GetSingle(ByVal idx&) As Single
    GetSingle = CSng(m_aiData(idx + 1)) + CSng(&HFFFF& And m_aiData(idx)) / &H10000
End Function
