VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CEnumFonts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Klasse    : cEnumFonts
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
'---------------------------------------------------------------------------------------

Option Explicit

Private Const LB_ADDSTRING = &H180
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function EnumFontFamilies Lib "gdi32" Alias "EnumFontFamiliesA" (ByVal hDC As Long, ByVal lpszFamily As String, ByVal lpEnumFontFamProc As Long, ByVal lParam As EFontArrangement) As Long

Private lst As ListBox

'/ Konstanten fr Art der Ergibnismenge
Public Enum EFillOptions
    GET_NAMES = EFontArrangement.GetNames
    GET_FULLNAMES = EFontArrangement.GetFullNames
    GET_STYLES = EFontArrangement.GetStyle
End Enum

Public FontTypeMask As EFontType

'Listbox fllen
Public Sub FillList(lstBox As ListBox, Optional ByVal Options As EFillOptions = GET_NAMES, Optional FontFamily As String = vbNullString)
    Set lst = lstBox
    Call EnumFontFamilies(lst.Parent.hDC, FontFamily, AddressOf EnumFontFamProc, Options Or OutputList)
    Set GEnumFonts.oEFnts = Nothing
    Set lst = Nothing
End Sub

'/ Die eigentlich arbeitende Callback-Routine
Friend Sub EnumFontFamP( _
                        lpElf As GEnumFonts.ENUMLOGFONT, _
                        lpNtm As GEnumFonts.NEWTEXTMETRIC, _
                        ByVal FontType As EFontType, _
                        ByVal lParam As EFontArrangement)
    
    '/ Zeiger auf nullterminierte Ansii-Zeichenkette
    Static ptrAStr&
    
    '/ Schrifttypen die nicht der Maske entsprechen berspringen
    If (FontType And FontTypeMask) = EFontType.NO_FONTTYPE Then Exit Sub

    '/ Je nach Aufgabe den Zeiger auf die Zeichenkette in der Datenstruktur setzen
    If (lParam And GET_NAMES) > 0 Then          ' Name
        ptrAStr = VarPtr(lpElf.elfLogFont.lfFaceName(1))
    ElseIf (lParam And GET_FULLNAMES) > 0 Then  ' FullName
        If FontType = TRUETYPE_FONTTYPE Then
            ptrAStr = VarPtr(lpElf.elfFullName(0))
        Else
            ptrAStr = VarPtr(lpElf.elfLogFont.lfFaceName(1))
        End If
    ElseIf (lParam And GET_STYLES) > 0 Then     ' Style
        If FontType <> TRUETYPE_FONTTYPE Then Exit Sub
        ptrAStr = VarPtr(lpElf.elfStyle(0))
    End If
    SendMessage lst.hwnd, LB_ADDSTRING, ByVal 0, ByVal ptrAStr
End Sub

Private Sub Class_Initialize()
    '/ Referenz auf eigene Instanz hinterlegen
    Set GEnumFonts.oEFnts = Me
    FontTypeMask = TRUETYPE_FONTTYPE Or RASTER_FONTTYPE
End Sub

Private Sub Class_Terminate()
    Set GEnumFonts.oEFnts = Nothing
End Sub


