VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCanvas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Klasse    : cCanvas
' Datum     : 21.01.2003
' Autor     : G.Beckmann - Email:G.Beckmann@NikoCity.de
' Zweck     : Zeichenflche fr Textzeichen-Umrisse
'---------------------------------------------------------------------------------------

Option Explicit

Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Declare Function MoveToEx& Lib "gdi32" (ByVal hDC&, ByVal x&, ByVal y&, lpPoint As Any)
Private Declare Function LineTo& Lib "gdi32" (ByVal hDC&, ByVal x&, ByVal y&)
Private Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Const PS_SOLID = 0


Private m_hBmp          As Long
Private m_hDC           As Long
Private m_iBackColor    As Long
Private m_iWidth        As Long
Private m_iHeight       As Long
Private WithEvents m_PB As PictureBox
Attribute m_PB.VB_VarHelpID = -1
Private m_fMetrics      As Boolean
Private m_dx            As Long
Private m_dy            As Long

Friend Sub MirrorY(ByVal f As Boolean)
    Dim m2 As MAT2
    
    If f Then
        m_dx = 40
        m_dy = 400
        m2.eM11.Value = 1
        m2.eM22.Value = -1
    Else
        m_dx = 40
        m_dy = 120
        m2.eM11.Value = 1
        m2.eM22.Value = 1
    End If
    SetTransformationMatrix m2
End Sub

Friend Sub Attach(ByVal pb As PictureBox)
    Dim hDC&
    
    MirrorY False
    
    Set m_PB = pb
    pb.ScaleMode = vbPixels
    pb.AutoRedraw = False
    
    hDC = GetDC(0)
    
    m_iWidth = m_PB.ScaleWidth
    m_iHeight = m_PB.ScaleHeight
    m_hBmp = CreateCompatibleBitmap(hDC, m_iWidth, m_iHeight)
    
    m_hDC = CreateCompatibleDC(hDC)
    ReleaseDC 0, hDC
    
    Call DeleteObject(SelectObject(m_hDC, m_hBmp))
    
    m_iBackColor = pb.BackColor
'    m_iForeColor = pb.ForeColor
    ClearScreen
End Sub

Friend Sub Detach()
    If m_hDC Then
        Set m_PB = Nothing
        DeleteDC m_hDC
        m_hDC = 0
    End If
End Sub

Friend Sub ClearScreen()
    Dim hBrush  As Long
    Dim rc      As RECT
    
    If m_hBmp Then
        If m_iBackColor < 0 Then
            hBrush = CreateSolidBrush(GetSysColor(m_iBackColor And &HFF&))
        Else
            hBrush = CreateSolidBrush(m_iBackColor)
        End If
        
        rc.Right = m_iWidth
        rc.Bottom = m_iHeight
        FillRect m_hDC, rc, hBrush
        
        DeleteObject hBrush
    End If
End Sub

Friend Property Get hDC() As Long
    hDC = m_hDC
End Property

Friend Sub Refresh()
  BitBlt m_PB.hDC, 0, 0, m_iWidth, m_iHeight, m_hDC, 0, 0, vbSrcCopy
End Sub

Private Sub Class_Terminate()
    Detach
End Sub

Friend Sub DrawPolygons(ByVal polygons As TTPolygons)
    ClearScreen
    DrawMetrics polygons
    polygons.Draw m_hDC, m_dx, m_dy
    Refresh
End Sub

Friend Sub HighlightPolyCurve(ByVal polygons As TTPolygons, ByVal Polycurve As ttpolycurve)
    Dim hPen    As Long
    
    ClearScreen
    DrawMetrics polygons
    polygons.Draw m_hDC, m_dx, m_dy
    
    hPen = CreatePen(PS_SOLID, 3, &HC0)
    hPen = SelectObject(m_hDC, hPen)
    Polycurve.Draw m_hDC, m_dx, m_dy
    hPen = SelectObject(m_hDC, hPen)
    DeleteObject hPen
    
    Refresh
End Sub

Friend Sub HighlightPolygone(ByVal polygons As TTPolygons, ByVal Polygone As TTPolygon)
    Dim hPen    As Long
    
    ClearScreen
    DrawMetrics polygons
    polygons.Draw m_hDC, m_dx, m_dy
    
    hPen = CreatePen(PS_SOLID, 3, &HC0)
    hPen = SelectObject(m_hDC, hPen)
    Polygone.Draw m_hDC, m_dx, m_dy
    hPen = SelectObject(m_hDC, hPen)
    DeleteObject hPen
    
    Refresh
End Sub

Friend Sub HighlightPoint(ByVal polygons As TTPolygons, ByVal xPos As Long, ByVal yPos As Long)
    Dim hPen    As Long
    
    ClearScreen
    DrawMetrics polygons
    polygons.Draw m_hDC, m_dx, m_dy
    
    hPen = CreatePen(PS_SOLID, 5, &HC0)
    hPen = SelectObject(m_hDC, hPen)
    MoveToEx m_hDC, xPos + m_dx, yPos + m_dy, ByVal 0&
    LineTo m_hDC, xPos + m_dx, yPos + m_dy
 
    hPen = SelectObject(m_hDC, hPen)
    DeleteObject hPen
    
    Refresh
End Sub

Friend Property Get BackColor() As Long
    BackColor = m_iBackColor
End Property

Friend Property Let BackColor(ByVal iBackColor As Long)
    m_iBackColor = iBackColor
End Property

Private Sub DrawMetrics(polygons As TTPolygons)
    Dim gm      As Glyphmetrics
    Dim x       As Long
    Dim y       As Long
    Dim hPen    As Long
    Dim hPenOrg As Long
    
    If Not m_fMetrics Then Exit Sub
    
    gm = polygons.Metrics
    x = gm.gmptGlyphOrigin.x + m_dx
    y = gm.gmptGlyphOrigin.y + m_dy
    
    hPen = CreatePen(PS_SOLID, 1, &HFFFFFF)
    hPenOrg = SelectObject(m_hDC, hPen)
    Rectangle m_hDC, x, y - gm.gmBlackBoxY, gm.gmBlackBoxX + x + 1, y + 1
    
    hPen = CreatePen(PS_SOLID, 1, &HC00000)
    hPen = SelectObject(m_hDC, hPen)
    DeleteObject hPen
    MoveToEx m_hDC, gm.gmCellIncX + m_dx, 0, ByVal 0&
    LineTo m_hDC, gm.gmCellIncX + m_dx, m_iHeight
    
    MoveToEx m_hDC, 0, gm.gmCellIncY + m_dy, ByVal 0&
    LineTo m_hDC, m_iWidth, gm.gmCellIncY + m_dy
    
    hPen = SelectObject(m_hDC, hPenOrg)
    DeleteObject hPen
End Sub

Friend Property Get Metrics() As Boolean
    Metrics = m_fMetrics
End Property

Friend Property Let Metrics(ByVal fMetrics As Boolean)
    m_fMetrics = fMetrics
End Property

Private Sub m_PB_Paint()
    Refresh
End Sub
